<?php

namespace Treewec\DirectoryIterators;

/**
 * Test class for NextDoorNeighbours.
 * Generated by PHPUnit on 2012-07-04 at 09:38:42.
 * @group directory_iterators
 */
// PRECONDITION: userComparator is set in TREEWEC_DEFAULT_COMPARATOR
class NextDoorNeighboursTest extends \PHPUnit_Framework_TestCase {

    /** @var array from NextDoorNeighbours::getNextDoorNeighbours */
    private $nextDoor;

    public function testLeftFile() {
        $this->loadNextDoor('test.php');
        parent::assertNull($this->nextDoor['P']);
        parent::assertTrue(is_string($this->nextDoor['N']));
    }

    public function testCenterFile() {
        $this->loadNextDoor('existing-žeš');
        parent::assertTrue(is_string($this->nextDoor['P']));
        parent::assertTrue(is_string($this->nextDoor['N']));
    }

    public function testRightFile() {
        $this->loadNextDoor('existing');
        parent::assertTrue(is_string($this->nextDoor['P']));
        parent::assertNull($this->nextDoor['N']);
    }

    public function testInvalidFile() {
        $exceptionHelper = new \Treewec\ExceptionHelper();
        $exceptionHelper->catchExceptionInConstructor('\Treewec\Exceptions\FileSystemException', '\Treewec\DirectoryIterators\NextDoorNeighbours', 'unexisting-path');
    }

    private function loadNextDoor($filename) {
        $filename = \Treewec\FileSystem\Path::toFileSystem($filename);
        $nextDoor = new NextDoorNeighbours(TEMP_FILEDIR . $filename);
        $this->nextDoor = $nextDoor->getNextDoorNeighbours();
    }

}

?>
